<?php


function fromDER(string $der, int $partLength)
{
	$hex = unpack('H*', $der)[1];
	if ('30' !== mb_substr($hex, 0, 2, '8bit')) { // SEQUENCE
		throw new \RuntimeException();
	}
	if ('81' === mb_substr($hex, 2, 2, '8bit')) { // LENGTH > 128
		$hex = mb_substr($hex, 6, null, '8bit');
	} else {
		$hex = mb_substr($hex, 4, null, '8bit');
	}
	if ('02' !== mb_substr($hex, 0, 2, '8bit')) { // INTEGER
		throw new \RuntimeException();
	}
	$Rl = hexdec(mb_substr($hex, 2, 2, '8bit'));
	$R = retrievePositiveInteger(mb_substr($hex, 4, $Rl * 2, '8bit'));
	$R = str_pad($R, $partLength, '0', STR_PAD_LEFT);
	$hex = mb_substr($hex, 4 + $Rl * 2, null, '8bit');
	if ('02' !== mb_substr($hex, 0, 2, '8bit')) { // INTEGER
		throw new \RuntimeException();
	}
	$Sl = hexdec(mb_substr($hex, 2, 2, '8bit'));
	$S = retrievePositiveInteger(mb_substr($hex, 4, $Sl * 2, '8bit'));
	$S = str_pad($S, $partLength, '0', STR_PAD_LEFT);
	return pack('H*', $R.$S);
}

function preparePositiveInteger(string $data)
{
	if (mb_substr($data, 0, 2, '8bit') > '7f') {
		return '00'.$data;
	}
	while ('00' === mb_substr($data, 0, 2, '8bit') && mb_substr($data, 2, 2, '8bit') <= '7f') {
		$data = mb_substr($data, 2, null, '8bit');
	}
	return $data;
}
/**
 * @param string $data
 *
 * @return string
 */
function retrievePositiveInteger(string $data)
{
	while ('00' === mb_substr($data, 0, 2, '8bit') && mb_substr($data, 2, 2, '8bit') > '7f') {
		$data = mb_substr($data, 2, null, '8bit');
	}
	return $data;
}


function encode($data) {
    $encoded = strtr(base64_encode($data), '+/', '-_');
    return rtrim($encoded, '=');
}

function generateJWT($kid, $iss, $sub, $key) {
    $header = [
        'alg' => 'ES256',
        'kid' => $kid
    ];
    $body = [
        'iss' => $iss,
        'iat' => time(),
        'exp' => time() + 3600,
        'aud' => 'https://appleid.Apple.com',
        'sub' => $sub
    ];

    $privKey = openssl_pkey_get_private($key);
    if (!$privKey) return false;

    $payload = encode(json_encode($header)).'.'.encode(json_encode($body));
    $signature = '';
    $success = openssl_sign($payloads, $signature, $key, OPENSSL_ALGO_SHA256);

	//echo 'payload==='.$payload;
	

    //if (!$success) return false;

	$raw_signature = fromDER($signature, 64);

	echo 'raw_signature==='.$raw_signature;


    return $payload.'.'.encode($raw_signature);
	//return $payload.'.'.encode($signature);
}


$key = <<<EOD
-----BEGIN PRIVATE KEY-----
MIGTAgEAMBMGByqGSM49AgEGCCqGSM49AwEHBHkwdwIBAQQgvcAjwhHllp6X0VL4
qCt40nZnjbc/KfXfl1p2D+oNP9ugCgYIKoZIzj0DAQehRANCAAR3A9s7UNJgK8Sk
F9Vtn+YmgXHm5xhPgxJzaujpHIdtT3acZIwZwse9MZGT2O9jja25/kL9OxjY4AIY
nedZzr2E
-----END PRIVATE KEY-----
EOD;

$kid = '25752Z5GNA'; // identifier for private key
$iss = '38677HJ2W9'; // team identifier
//$sub = '38677HJ2W9.com.sameboard.SameBoard1'; // my app id
$sub = '38677HJ2W9.38677HJ2W9.com.sameboard.SameBoard1';

$jwt = generateJWT($kid, $iss, $sub, $key);

echo '--====jwt_client_secret======'.$jwt;

$data = [
    'client_id' => $sub,
    'client_secret' => $jwt,
   // 'code' => 'cac1b7812ea994097b1ac9d2497728036.0.rwzv.1ngAQmEQr6s1jDX8t9hakw',
	'code' => $_POST['code'],
    'grant_type' => 'authorization_code'
    //'request_uri' => 'https://toshow.kr:4430/apple/apple.php'
];
$ch = curl_init();

//curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
//curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
curl_setopt($ch, CURLOPT_URL, 'https://appleid.Apple.com/auth/token');
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);


$serverOutput = curl_exec($ch);

echo 'serverOutput==='.$serverOutput;


//curl_close ($ch);

?>